<?php

namespace STM\Match\Period;

use STM\Match\Match;
use STM\Match\MatchSelection;
use \Exception;
use STM\StmFactory;

/**
 * Test class for Period.
 * Generated by PHPUnit on 2011-08-15 at 20:27:44.
 * @group match_period
 */
class PeriodTest extends \PHPUnit_Framework_TestCase {

    private $bad_values;
    private $all_periods;
    private $all_matches;
    /** @var PeriodFactory */
    private $factoryFind;
    /** @var PeriodFactory */
    private $factoryCount;

    protected function setUp() {
        $this->bad_values = array('', null, false, array(), new Exception());

        $this->allMatches = getMatches(MatchSelection::ALL_MATCHES);
        $this->all_periods = array();
        $this->factoryFind = new PeriodFactory();
        $this->factoryCount = new PeriodFactory();
        $this->factoryCount->setCount();
        foreach ($this->allMatches as $match) {
            foreach ($this->factoryFind->findByMatch($match) as $match_period) {
                $this->all_periods[] = $match_period;
            }
        }
    }

    protected function tearDown() {}

    public function testFind_by_match() {
        // all periods found by findByMatch
        foreach ($this->all_periods as $period) {
            parent::assertInstanceOf('\STM\Match\Period\Period', $period);
        }
    }

    public function testfindCountPeriods() {
        foreach ($this->allMatches as $match) {
            $this->assertTrue(is_int($this->factoryCount->findByMatch($match)));
        }
    }

    public function testCreate() {
        $this->markTestSkipped('in PeriodValidatorTest');
    }

    public function testDelete_match_periods() {
        foreach ($this->allMatches as $match) {
            if ($this->factoryCount->findByMatch($match) == 0) {
                $this->assertFalse(Period::deleteMatchPeriods($match));
            }
        }
    }

    public function testDelete() {
        $this->markTestSkipped('Only fail in database');
    }

    public function testUpdate() {
        $this->markTestSkipped('in PeriodValidatorTest');
    }

    public function testGet_note() {
        foreach ($this->all_periods as $period) {
            $note = $period->getNote();
            if ($note) {
                $this->assertTrue(is_string($note));
            } else {
                $this->assertFalse($note);
            }
        }
    }

    public function testTo_array() {
        foreach ($this->all_periods as $period) {
            $this->assertArrayHasKey('id_period', $period->toArray());
            $this->assertArrayHasKey('score_home', $period->toArray());
            $this->assertArrayHasKey('score_away', $period->toArray());
            $this->assertArrayHasKey('note', $period->toArray());
        }
    }

    public function test__toString() {
        foreach ($this->all_periods as $period) {
            $this->assertTrue(is_string($period->__toString()));
        }
    }

}

?>
